/*
POS API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package posapi

import (
	"encoding/json"
)

// checks if the AddReceiptWebhookReceipt type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AddReceiptWebhookReceipt{}

// AddReceiptWebhookReceipt struct for AddReceiptWebhookReceipt
type AddReceiptWebhookReceipt struct {
	Status string `json:"status"`
	Error *string `json:"error,omitempty"`
	LocationId *string `json:"location_id,omitempty"`
	Time *string `json:"time,omitempty"`
	Date *string `json:"date,omitempty"`
	Total *string `json:"total,omitempty"`
}

// NewAddReceiptWebhookReceipt instantiates a new AddReceiptWebhookReceipt object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAddReceiptWebhookReceipt(status string) *AddReceiptWebhookReceipt {
	this := AddReceiptWebhookReceipt{}
	this.Status = status
	return &this
}

// NewAddReceiptWebhookReceiptWithDefaults instantiates a new AddReceiptWebhookReceipt object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAddReceiptWebhookReceiptWithDefaults() *AddReceiptWebhookReceipt {
	this := AddReceiptWebhookReceipt{}
	return &this
}

// GetStatus returns the Status field value
func (o *AddReceiptWebhookReceipt) GetStatus() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Status
}

// GetStatusOk returns a tuple with the Status field value
// and a boolean to check if the value has been set.
func (o *AddReceiptWebhookReceipt) GetStatusOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Status, true
}

// SetStatus sets field value
func (o *AddReceiptWebhookReceipt) SetStatus(v string) {
	o.Status = v
}

// GetError returns the Error field value if set, zero value otherwise.
func (o *AddReceiptWebhookReceipt) GetError() string {
	if o == nil || IsNil(o.Error) {
		var ret string
		return ret
	}
	return *o.Error
}

// GetErrorOk returns a tuple with the Error field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AddReceiptWebhookReceipt) GetErrorOk() (*string, bool) {
	if o == nil || IsNil(o.Error) {
		return nil, false
	}
	return o.Error, true
}

// HasError returns a boolean if a field has been set.
func (o *AddReceiptWebhookReceipt) HasError() bool {
	if o != nil && !IsNil(o.Error) {
		return true
	}

	return false
}

// SetError gets a reference to the given string and assigns it to the Error field.
func (o *AddReceiptWebhookReceipt) SetError(v string) {
	o.Error = &v
}

// GetLocationId returns the LocationId field value if set, zero value otherwise.
func (o *AddReceiptWebhookReceipt) GetLocationId() string {
	if o == nil || IsNil(o.LocationId) {
		var ret string
		return ret
	}
	return *o.LocationId
}

// GetLocationIdOk returns a tuple with the LocationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AddReceiptWebhookReceipt) GetLocationIdOk() (*string, bool) {
	if o == nil || IsNil(o.LocationId) {
		return nil, false
	}
	return o.LocationId, true
}

// HasLocationId returns a boolean if a field has been set.
func (o *AddReceiptWebhookReceipt) HasLocationId() bool {
	if o != nil && !IsNil(o.LocationId) {
		return true
	}

	return false
}

// SetLocationId gets a reference to the given string and assigns it to the LocationId field.
func (o *AddReceiptWebhookReceipt) SetLocationId(v string) {
	o.LocationId = &v
}

// GetTime returns the Time field value if set, zero value otherwise.
func (o *AddReceiptWebhookReceipt) GetTime() string {
	if o == nil || IsNil(o.Time) {
		var ret string
		return ret
	}
	return *o.Time
}

// GetTimeOk returns a tuple with the Time field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AddReceiptWebhookReceipt) GetTimeOk() (*string, bool) {
	if o == nil || IsNil(o.Time) {
		return nil, false
	}
	return o.Time, true
}

// HasTime returns a boolean if a field has been set.
func (o *AddReceiptWebhookReceipt) HasTime() bool {
	if o != nil && !IsNil(o.Time) {
		return true
	}

	return false
}

// SetTime gets a reference to the given string and assigns it to the Time field.
func (o *AddReceiptWebhookReceipt) SetTime(v string) {
	o.Time = &v
}

// GetDate returns the Date field value if set, zero value otherwise.
func (o *AddReceiptWebhookReceipt) GetDate() string {
	if o == nil || IsNil(o.Date) {
		var ret string
		return ret
	}
	return *o.Date
}

// GetDateOk returns a tuple with the Date field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AddReceiptWebhookReceipt) GetDateOk() (*string, bool) {
	if o == nil || IsNil(o.Date) {
		return nil, false
	}
	return o.Date, true
}

// HasDate returns a boolean if a field has been set.
func (o *AddReceiptWebhookReceipt) HasDate() bool {
	if o != nil && !IsNil(o.Date) {
		return true
	}

	return false
}

// SetDate gets a reference to the given string and assigns it to the Date field.
func (o *AddReceiptWebhookReceipt) SetDate(v string) {
	o.Date = &v
}

// GetTotal returns the Total field value if set, zero value otherwise.
func (o *AddReceiptWebhookReceipt) GetTotal() string {
	if o == nil || IsNil(o.Total) {
		var ret string
		return ret
	}
	return *o.Total
}

// GetTotalOk returns a tuple with the Total field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AddReceiptWebhookReceipt) GetTotalOk() (*string, bool) {
	if o == nil || IsNil(o.Total) {
		return nil, false
	}
	return o.Total, true
}

// HasTotal returns a boolean if a field has been set.
func (o *AddReceiptWebhookReceipt) HasTotal() bool {
	if o != nil && !IsNil(o.Total) {
		return true
	}

	return false
}

// SetTotal gets a reference to the given string and assigns it to the Total field.
func (o *AddReceiptWebhookReceipt) SetTotal(v string) {
	o.Total = &v
}

func (o AddReceiptWebhookReceipt) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AddReceiptWebhookReceipt) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["status"] = o.Status
	if !IsNil(o.Error) {
		toSerialize["error"] = o.Error
	}
	if !IsNil(o.LocationId) {
		toSerialize["location_id"] = o.LocationId
	}
	if !IsNil(o.Time) {
		toSerialize["time"] = o.Time
	}
	if !IsNil(o.Date) {
		toSerialize["date"] = o.Date
	}
	if !IsNil(o.Total) {
		toSerialize["total"] = o.Total
	}
	return toSerialize, nil
}

type NullableAddReceiptWebhookReceipt struct {
	value *AddReceiptWebhookReceipt
	isSet bool
}

func (v NullableAddReceiptWebhookReceipt) Get() *AddReceiptWebhookReceipt {
	return v.value
}

func (v *NullableAddReceiptWebhookReceipt) Set(val *AddReceiptWebhookReceipt) {
	v.value = val
	v.isSet = true
}

func (v NullableAddReceiptWebhookReceipt) IsSet() bool {
	return v.isSet
}

func (v *NullableAddReceiptWebhookReceipt) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAddReceiptWebhookReceipt(val *AddReceiptWebhookReceipt) *NullableAddReceiptWebhookReceipt {
	return &NullableAddReceiptWebhookReceipt{value: val, isSet: true}
}

func (v NullableAddReceiptWebhookReceipt) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAddReceiptWebhookReceipt) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


